var _reactUiAriaInteractions = require("@react-ui-aria/interactions");

var _reactUiAriaUtils = require("@react-ui-aria/utils");

var _babelRuntimeHelpersExtends = require("@babel/runtime/helpers/extends");

var _babelRuntimeHelpersInteropRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
// ASSET: /home/cong/Github/ladifire/ladifire-ui-react/packages/@react-ui-aria/toast/src/useToast.ts
var $f124e46bf265bf439097264b415ac3$exports = {};
var $f124e46bf265bf439097264b415ac3$var$_interopRequireDefault = _babelRuntimeHelpersInteropRequireDefault;
Object.defineProperty($f124e46bf265bf439097264b415ac3$exports, "__esModule", {
  value: true
});
var $f124e46bf265bf439097264b415ac3$export$useToast = $f124e46bf265bf439097264b415ac3$var$useToast;
$f124e46bf265bf439097264b415ac3$exports.useToast = $f124e46bf265bf439097264b415ac3$export$useToast;
var $f124e46bf265bf439097264b415ac3$var$_extends2 = $f124e46bf265bf439097264b415ac3$var$_interopRequireDefault(_babelRuntimeHelpersExtends);
var $f124e46bf265bf439097264b415ac3$var$_utils = _reactUiAriaUtils;
var $f124e46bf265bf439097264b415ac3$var$_interactions = _reactUiAriaInteractions;

/*
 * Copyright 2020 Ladifire. All rights reserved.
 * This file is licensed to you under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. You may obtain a copy
 * of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS
 * OF ANY KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
function $f124e46bf265bf439097264b415ac3$var$useToast(props, state) {
  let {
    toastKey,
    onAction,
    onClose,
    shouldCloseOnAction,
    timer,
    variant
  } = props;
  let {
    onRemove
  } = state;
  let domProps = (0, $f124e46bf265bf439097264b415ac3$var$_utils.filterDOMProps)(props);

  const handleAction = function handleAction() {
    if (onAction) {
      onAction(...arguments);
    }

    if (shouldCloseOnAction) {
      onClose && onClose(...arguments);
      onRemove && onRemove(toastKey);
    }
  };

  let iconProps = variant ? {
    'aria-label': variant
  } : {};

  let pauseTimer = () => {
    timer && timer.pause();
  };

  let resumeTimer = () => {
    timer && timer.resume();
  };

  let {
    hoverProps
  } = (0, $f124e46bf265bf439097264b415ac3$var$_interactions.useHover)({
    onHoverStart: pauseTimer,
    onHoverEnd: resumeTimer
  });
  let {
    focusProps
  } = (0, $f124e46bf265bf439097264b415ac3$var$_interactions.useFocus)({
    onFocus: pauseTimer,
    onBlur: resumeTimer
  });
  return {
    toastProps: (0, $f124e46bf265bf439097264b415ac3$var$_utils.mergeProps)(domProps, (0, $f124e46bf265bf439097264b415ac3$var$_extends2.default)({}, hoverProps, {
      role: 'alert'
    })),
    iconProps,
    actionButtonProps: (0, $f124e46bf265bf439097264b415ac3$var$_extends2.default)({}, focusProps, {
      onPress: handleAction
    }),
    closeButtonProps: (0, $f124e46bf265bf439097264b415ac3$var$_extends2.default)({
      'aria-label': 'close'
    }, focusProps, {
      onPress: (0, $f124e46bf265bf439097264b415ac3$var$_utils.chain)(onClose, () => onRemove(toastKey))
    })
  };
}

Object.keys($f124e46bf265bf439097264b415ac3$exports).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return $f124e46bf265bf439097264b415ac3$exports[key];
    }
  });
});
//# sourceMappingURL=main.js.map
