import _reactUiAriaInteractions from "@react-ui-aria/interactions";
import _reactUiAriaUtils from "@react-ui-aria/utils";
import _babelRuntimeHelpersEsmExtends from "@babel/runtime/helpers/esm/extends";
import _babelRuntimeHelpersInteropRequireDefault from "@babel/runtime/helpers/interopRequireDefault";
// ASSET: /home/cong/Github/ladifire/ladifire-ui-react/packages/@react-ui-aria/toast/src/index.ts
var $c1c6c64eb90109099638fcfb43ed97c$exports = {};
Object.defineProperty($c1c6c64eb90109099638fcfb43ed97c$exports, "__esModule", {
  value: true
});
// ASSET: /home/cong/Github/ladifire/ladifire-ui-react/packages/@react-ui-aria/toast/src/useToast.ts
var $d73bf89f7e1345e518a39434d1b41f4$exports = {};
var $d73bf89f7e1345e518a39434d1b41f4$var$_interopRequireDefault = _babelRuntimeHelpersInteropRequireDefault;
Object.defineProperty($d73bf89f7e1345e518a39434d1b41f4$exports, "__esModule", {
  value: true
});
var $d73bf89f7e1345e518a39434d1b41f4$export$useToast = $d73bf89f7e1345e518a39434d1b41f4$var$useToast;
$d73bf89f7e1345e518a39434d1b41f4$exports.useToast = $d73bf89f7e1345e518a39434d1b41f4$export$useToast;
var $d73bf89f7e1345e518a39434d1b41f4$var$_extends2 = $d73bf89f7e1345e518a39434d1b41f4$var$_interopRequireDefault(_babelRuntimeHelpersEsmExtends);
var $d73bf89f7e1345e518a39434d1b41f4$var$_utils = _reactUiAriaUtils;
var $d73bf89f7e1345e518a39434d1b41f4$var$_interactions = _reactUiAriaInteractions;

/*
 * Copyright 2020 Ladifire. All rights reserved.
 * This file is licensed to you under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. You may obtain a copy
 * of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS
 * OF ANY KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
function $d73bf89f7e1345e518a39434d1b41f4$var$useToast(props, state) {
  let {
    toastKey,
    onAction,
    onClose,
    shouldCloseOnAction,
    timer,
    variant
  } = props;
  let {
    onRemove
  } = state;
  let domProps = (0, $d73bf89f7e1345e518a39434d1b41f4$var$_utils.filterDOMProps)(props);

  const handleAction = function handleAction() {
    if (onAction) {
      onAction(...arguments);
    }

    if (shouldCloseOnAction) {
      onClose && onClose(...arguments);
      onRemove && onRemove(toastKey);
    }
  };

  let iconProps = variant ? {
    'aria-label': variant
  } : {};

  let pauseTimer = () => {
    timer && timer.pause();
  };

  let resumeTimer = () => {
    timer && timer.resume();
  };

  let {
    hoverProps
  } = (0, $d73bf89f7e1345e518a39434d1b41f4$var$_interactions.useHover)({
    onHoverStart: pauseTimer,
    onHoverEnd: resumeTimer
  });
  let {
    focusProps
  } = (0, $d73bf89f7e1345e518a39434d1b41f4$var$_interactions.useFocus)({
    onFocus: pauseTimer,
    onBlur: resumeTimer
  });
  return {
    toastProps: (0, $d73bf89f7e1345e518a39434d1b41f4$var$_utils.mergeProps)(domProps, (0, $d73bf89f7e1345e518a39434d1b41f4$var$_extends2.default)({}, hoverProps, {
      role: 'alert'
    })),
    iconProps,
    actionButtonProps: (0, $d73bf89f7e1345e518a39434d1b41f4$var$_extends2.default)({}, focusProps, {
      onPress: handleAction
    }),
    closeButtonProps: (0, $d73bf89f7e1345e518a39434d1b41f4$var$_extends2.default)({
      'aria-label': 'close'
    }, focusProps, {
      onPress: (0, $d73bf89f7e1345e518a39434d1b41f4$var$_utils.chain)(onClose, () => onRemove(toastKey))
    })
  };
}

Object.keys($d73bf89f7e1345e518a39434d1b41f4$exports).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty($c1c6c64eb90109099638fcfb43ed97c$exports, key, {
    enumerable: true,
    get: function get() {
      return $d73bf89f7e1345e518a39434d1b41f4$exports[key];
    }
  });
});
//# sourceMappingURL=module.js.map
